package adminkindboxvalidator

type Repository interface {
	KindBoxRequestExist(id uint) (bool, error)
	EmployeeExist(id uint) (bool, error)
	BenefactorExist(id uint) (bool, error)
	KindBoxExist(id uint) (bool, error)
	KindBoxBelongToBenefactor(benefactorID uint, kindboxID uint) (bool, error)
	PendingStatus(id uint) (bool, error)
	CheckStatus(status string) (bool, error)
}

type Validator struct {
	repo Repository
}

func New(repo Repository) Validator {
	return Validator{repo: repo}
}

// func (v Validator) doesKindBoxRequestExist(value interface{}) error {
//	receiverID, ok := value.(uint)
//	if !ok {
//		return fmt.Errorf(errmsg.ErrorMsgSomethingWentWrong)
//	}
//	_, err := v.repo.KindBoxRequestExist(receiverID)
//	if err != nil {
//		return fmt.Errorf(errmsg.ErrorMsgNotFound)
//	}
//
//	return nil
//}
//
// func (v Validator) doesEmployeeExist(value interface{}) error {
//	senderID, ok := value.(uint)
//	if !ok {
//		return fmt.Errorf(errmsg.ErrorMsgSomethingWentWrong)
//	}
//	_, err := v.repo.EmployeeExist(senderID)
//	if err != nil {
//		return fmt.Errorf(errmsg.ErrorMsgNotFound)
//	}
//
//	return nil
//}
//
// func (v Validator) doesBenefactorExist(value interface{}) error {
//	benefactorID, ok := value.(uint)
//	if !ok {
//		return fmt.Errorf(errmsg.ErrorMsgSomethingWentWrong)
//	}
//	_, err := v.repo.BenefactorExist(benefactorID)
//	if err != nil {
//		return fmt.Errorf(errmsg.ErrorMsgNotFound)
//	}
//
//	return nil
//}
//
// func (v Validator) doesKindBoxExist(value interface{}) error {
//	kindboxID, ok := value.(uint)
//	if !ok {
//		return fmt.Errorf(errmsg.ErrorMsgNotFound)
//	}
//	_, err := v.repo.KindBoxExist(kindboxID)
//	if err != nil {
//		return fmt.Errorf(errmsg.ErrorMsgNotFound)
//	}
//
//	return nil
//}
//
// func (v Validator) doesKindBoxBelongToBenefactor(benefactorID uint) validation.RuleFunc {
//	return func(value interface{}) error {
//		kbID, ok := value.(uint)
//		if !ok {
//			return fmt.Errorf(errmsg.ErrorMsgNotFound)
//		}
//		_, err := v.repo.KindBoxBelongToBenefactor(benefactorID, kbID)
//		if err != nil {
//			return fmt.Errorf(errmsg.ErrorMsgNotFound)
//		}
//
//		return nil
//	}
//}

// TODO: this temperary to ignore linter error. (unused function)
// func (v Validator) hasCorrectStatus(value interface{}) error {
// 	status, ok := value.(string)
// 	if !ok {
// 		return fmt.Errorf(errmsg.ErrorMsgSomethingWentWrong)
// 	}
// 	_, err := v.repo.CheckStatus(status)
// 	if err != nil {
// 		return fmt.Errorf(errmsg.ErrorMsgNotFound)
// 	}

// 	return nil
// }

// func (v Validator) hasPendingStatus(value interface{}) error {
//	kindboxID, ok := value.(uint)
//	if !ok {
//		return fmt.Errorf(errmsg.ErrorMsgSomethingWentWrong)
//	}
//	_, err := v.repo.PendingStatus(kindboxID)
//	if err != nil {
//		return fmt.Errorf(errmsg.ErrorMsgNotFound)
//	}
//
//	return nil
//}
